diff --git a/sys/dev/raid/arcmsr/arcmsr.c b/sys/dev/raid/arcmsr/arcmsr.c
index f08380d..f0467c8 100644
--- a/sys/dev/raid/arcmsr/arcmsr.c
+++ b/sys/dev/raid/arcmsr/arcmsr.c
@@ -752,10 +825,10 @@ static void arcmsr_done4abort_postqueue(struct AdapterControlBlock *acb)
 			u_int32_t outbound_intstatus;
 
 			/*clear and abort all outbound posted Q*/
-			outbound_intstatus=CHIP_REG_READ32(HBA_MessageUnit, 0, outbound_intstatus) & acb->outbound_int_enable;
+			outbound_intstatus = CHIP_REG_READ32(HBA_MessageUnit, 0, outbound_intstatus) & acb->outbound_int_enable;
 			CHIP_REG_WRITE32(HBA_MessageUnit, 0, outbound_intstatus, outbound_intstatus);/*clear interrupt*/
 			while(((flag_srb=CHIP_REG_READ32(HBA_MessageUnit, 0, outbound_queueport)) != 0xFFFFFFFF) && (i++ < ARCMSR_MAX_OUTSTANDING_CMD)) {
-                error=(flag_srb & ARCMSR_SRBREPLY_FLAG_ERROR_MODE0)?TRUE:FALSE;
+                error = (flag_srb & ARCMSR_SRBREPLY_FLAG_ERROR_MODE0)?TRUE:FALSE;
 				arcmsr_drain_donequeue(acb, flag_srb, error);
 			}
 		}
@@ -766,26 +839,30 @@ static void arcmsr_done4abort_postqueue(struct AdapterControlBlock *acb)
 			/*clear all outbound posted Q*/
 			CHIP_REG_WRITE32(HBB_DOORBELL, 0, iop2drv_doorbell, ARCMSR_DOORBELL_INT_CLEAR_PATTERN); /* clear doorbell interrupt */
 			for(i=0; i < ARCMSR_MAX_HBB_POSTQUEUE; i++) {
-				if((flag_srb=phbbmu->done_qbuffer[i])!=0) {
-					phbbmu->done_qbuffer[i]=0;
-			error=(flag_srb & ARCMSR_SRBREPLY_FLAG_ERROR_MODE0)?TRUE:FALSE;
+				if((flag_srb = phbbmu->done_qbuffer[i]) != 0) {
+					phbbmu->done_qbuffer[i] = 0;
+                	error = (flag_srb & ARCMSR_SRBREPLY_FLAG_ERROR_MODE0)?TRUE:FALSE;
 					arcmsr_drain_donequeue(acb, flag_srb, error);
 				}
-				phbbmu->post_qbuffer[i]=0;
+				phbbmu->post_qbuffer[i] = 0;
 			}/*drain reply FIFO*/
-			phbbmu->doneq_index=0;
-			phbbmu->postq_index=0;
+			phbbmu->doneq_index = 0;
+			phbbmu->postq_index = 0;
 		}
 		break;
 	case ACB_ADAPTER_TYPE_C: {
 
 			while((CHIP_REG_READ32(HBC_MessageUnit, 0, host_int_status) & ARCMSR_HBCMU_OUTBOUND_POSTQUEUE_ISR) && (i++ < ARCMSR_MAX_OUTSTANDING_CMD)) {
-				flag_srb=CHIP_REG_READ32(HBC_MessageUnit, 0, outbound_queueport_low);
-                error=(flag_srb & ARCMSR_SRBREPLY_FLAG_ERROR_MODE1)?TRUE:FALSE;
+				flag_srb = CHIP_REG_READ32(HBC_MessageUnit, 0, outbound_queueport_low);
+                error = (flag_srb & ARCMSR_SRBREPLY_FLAG_ERROR_MODE1) ? TRUE : FALSE;
 				arcmsr_drain_donequeue(acb, flag_srb, error);
 			}
 		}
 		break;
+	case ACB_ADAPTER_TYPE_D: {
+			arcmsr_hbd_postqueue_isr(acb);
+		}
+		break;
 	}
 }
 /*
@@ -800,32 +877,30 @@ static void arcmsr_iop_reset(struct AdapterControlBlock *acb)
 
 	if(acb->srboutstandingcount>0) {
 		/* disable all outbound interrupt */
-		intmask_org=arcmsr_disable_allintr(acb);
+		intmask_org = arcmsr_disable_allintr(acb);
 		/*clear and abort all outbound posted Q*/
 		arcmsr_done4abort_postqueue(acb);
 		/* talk to iop 331 outstanding command aborted*/
 		arcmsr_abort_allcmd(acb);
-		for(i=0;i<ARCMSR_MAX_FREESRB_NUM;i++) {
-			srb=acb->psrb_pool[i];
-			if(srb->srb_state==ARCMSR_SRB_START) {
-				srb->srb_state=ARCMSR_SRB_ABORTED;
+		for(i=0; i < ARCMSR_MAX_FREESRB_NUM; i++) {
+			srb = acb->psrb_pool[i];
+			if(srb->srb_state == ARCMSR_SRB_START) {
+				srb->srb_state = ARCMSR_SRB_ABORTED;
 				srb->pccb->ccb_h.status |= CAM_REQ_ABORTED;
 				arcmsr_srb_complete(srb, 1);
-				kprintf("arcmsr%d: scsi id=%d lun=%d srb='%p' aborted\n"
+				kprintf("arcmsr%d: scsi id=%d lun=%jx srb='%p' aborted\n"
 						, acb->pci_unit, srb->pccb->ccb_h.target_id
-						, srb->pccb->ccb_h.target_lun, srb);
+						, (uintmax_t)srb->pccb->ccb_h.target_lun, srb);
 			}
 		}
 		/* enable all outbound interrupt */
 		arcmsr_enable_allintr(acb, intmask_org);
 	}
-	acb->srboutstandingcount=0;
-	acb->workingsrb_doneindex=0;
-	acb->workingsrb_startindex=0;
-#ifdef ARCMSR_DEBUG1
+	acb->srboutstandingcount = 0;
+	acb->workingsrb_doneindex = 0;
+	acb->workingsrb_startindex = 0;
 	acb->pktRequestCount = 0;
 	acb->pktReturnCount = 0;
-#endif
 }
 /*
 **********************************************************************
@@ -834,67 +909,66 @@ static void arcmsr_iop_reset(struct AdapterControlBlock *acb)
 static void arcmsr_build_srb(struct CommandControlBlock *srb,
 		bus_dma_segment_t *dm_segs, u_int32_t nseg)
 {
-	struct ARCMSR_CDB * arcmsr_cdb= &srb->arcmsr_cdb;
-	u_int8_t * psge=(u_int8_t *)&arcmsr_cdb->u;
+	struct ARCMSR_CDB *arcmsr_cdb = &srb->arcmsr_cdb;
+	u_int8_t *psge = (u_int8_t *)&arcmsr_cdb->u;
 	u_int32_t address_lo, address_hi;
-	union ccb * pccb=srb->pccb;
-	struct ccb_scsiio * pcsio= &pccb->csio;
-	u_int32_t arccdbsize=0x30;
+	union ccb *pccb = srb->pccb;
+	struct ccb_scsiio *pcsio = &pccb->csio;
+	u_int32_t arccdbsize = 0x30;
 
 	memset(arcmsr_cdb, 0, sizeof(struct ARCMSR_CDB));
-	arcmsr_cdb->Bus=0;
-	arcmsr_cdb->TargetID=pccb->ccb_h.target_id;
-	arcmsr_cdb->LUN=pccb->ccb_h.target_lun;
-	arcmsr_cdb->Function=1;
-	arcmsr_cdb->CdbLength=(u_int8_t)pcsio->cdb_len;
-	arcmsr_cdb->Context=0;
+	arcmsr_cdb->Bus = 0;
+	arcmsr_cdb->TargetID = pccb->ccb_h.target_id;
+	arcmsr_cdb->LUN = pccb->ccb_h.target_lun;
+	arcmsr_cdb->Function = 1;
+	arcmsr_cdb->CdbLength = (u_int8_t)pcsio->cdb_len;
 	bcopy(pcsio->cdb_io.cdb_bytes, arcmsr_cdb->Cdb, pcsio->cdb_len);
 	if(nseg != 0) {
-		struct AdapterControlBlock *acb=srb->acb;
+		struct AdapterControlBlock *acb = srb->acb;
 		bus_dmasync_op_t op;
-		u_int32_t length, i, cdb_sgcount=0;
+		u_int32_t length, i, cdb_sgcount = 0;
 
 		if((pccb->ccb_h.flags & CAM_DIR_MASK) == CAM_DIR_IN) {
-			op=BUS_DMASYNC_PREREAD;
+			op = BUS_DMASYNC_PREREAD;
 		} else {
-			op=BUS_DMASYNC_PREWRITE;
-			arcmsr_cdb->Flags|=ARCMSR_CDB_FLAG_WRITE;
-			srb->srb_flags|=SRB_FLAG_WRITE;
+			op = BUS_DMASYNC_PREWRITE;
+			arcmsr_cdb->Flags |= ARCMSR_CDB_FLAG_WRITE;
+			srb->srb_flags |= SRB_FLAG_WRITE;
 		}
 		bus_dmamap_sync(acb->dm_segs_dmat, srb->dm_segs_dmamap, op);
-		for(i=0;i<nseg;i++) {
+		for(i=0; i < nseg; i++) {
 			/* Get the physical address of the current data pointer */
-			length=arcmsr_htole32(dm_segs[i].ds_len);
-			address_lo=arcmsr_htole32(dma_addr_lo32(dm_segs[i].ds_addr));
-			address_hi=arcmsr_htole32(dma_addr_hi32(dm_segs[i].ds_addr));
-			if(address_hi==0) {
-				struct SG32ENTRY * pdma_sg=(struct SG32ENTRY *)psge;
-				pdma_sg->address=address_lo;
-				pdma_sg->length=length;
+			length = arcmsr_htole32(dm_segs[i].ds_len);
+			address_lo = arcmsr_htole32(dma_addr_lo32(dm_segs[i].ds_addr));
+			address_hi = arcmsr_htole32(dma_addr_hi32(dm_segs[i].ds_addr));
+			if(address_hi == 0) {
+				struct SG32ENTRY *pdma_sg = (struct SG32ENTRY *)psge;
+				pdma_sg->address = address_lo;
+				pdma_sg->length = length;
 				psge += sizeof(struct SG32ENTRY);
 				arccdbsize += sizeof(struct SG32ENTRY);
 			} else {
-				u_int32_t sg64s_size=0, tmplength=length;
+				u_int32_t sg64s_size = 0, tmplength = length;
 
 				while(1) {
 					u_int64_t span4G, length0;
-					struct SG64ENTRY * pdma_sg=(struct SG64ENTRY *)psge;
+					struct SG64ENTRY *pdma_sg = (struct SG64ENTRY *)psge;
 
-					span4G=(u_int64_t)address_lo + tmplength;
-					pdma_sg->addresshigh=address_hi;
-					pdma_sg->address=address_lo;
+					span4G = (u_int64_t)address_lo + tmplength;
+					pdma_sg->addresshigh = address_hi;
+					pdma_sg->address = address_lo;
 					if(span4G > 0x100000000) {
 						/*see if cross 4G boundary*/
-						length0=0x100000000-address_lo;
-						pdma_sg->length=(u_int32_t)length0|IS_SG64_ADDR;
-						address_hi=address_hi+1;
-						address_lo=0;
-						tmplength=tmplength-(u_int32_t)length0;
+						length0 = 0x100000000-address_lo;
+						pdma_sg->length = (u_int32_t)length0 | IS_SG64_ADDR;
+						address_hi = address_hi+1;
+						address_lo = 0;
+						tmplength = tmplength - (u_int32_t)length0;
 						sg64s_size += sizeof(struct SG64ENTRY);
 						psge += sizeof(struct SG64ENTRY);
 						cdb_sgcount++;
 					} else {
-						pdma_sg->length=tmplength|IS_SG64_ADDR;
+						pdma_sg->length = tmplength | IS_SG64_ADDR;
 						sg64s_size += sizeof(struct SG64ENTRY);
 						psge += sizeof(struct SG64ENTRY);
 						break;
@@ -904,15 +978,16 @@ static void arcmsr_build_srb(struct CommandControlBlock *srb,
 			}
 			cdb_sgcount++;
 		}
-		arcmsr_cdb->sgcount=(u_int8_t)cdb_sgcount;
-		arcmsr_cdb->DataLength=pcsio->dxfer_len;
+		arcmsr_cdb->sgcount = (u_int8_t)cdb_sgcount;
+		arcmsr_cdb->DataLength = pcsio->dxfer_len;
 		if( arccdbsize > 256) {
-			arcmsr_cdb->Flags|=ARCMSR_CDB_FLAG_SGL_BSIZE;
+			arcmsr_cdb->Flags |= ARCMSR_CDB_FLAG_SGL_BSIZE;
 		}
 	} else {
 		arcmsr_cdb->DataLength = 0;
 	}
-	srb->arc_cdb_size=arccdbsize;
+    srb->arc_cdb_size = arccdbsize;
+    arcmsr_cdb->msgPages = (arccdbsize/256) + ((arccdbsize % 256) ? 1 : 0);
 }
 /*
 **************************************************************************
@@ -920,46 +995,45 @@ static void arcmsr_build_srb(struct CommandControlBlock *srb,
 */
 static void arcmsr_post_srb(struct AdapterControlBlock *acb, struct CommandControlBlock *srb)
 {
-	u_int32_t cdb_shifted_phyaddr=(u_int32_t) srb->cdb_shifted_phyaddr;
-	struct ARCMSR_CDB * arcmsr_cdb=(struct ARCMSR_CDB *)&srb->arcmsr_cdb;
+	u_int32_t cdb_phyaddr_low = (u_int32_t) srb->cdb_phyaddr_low;
+	struct ARCMSR_CDB *arcmsr_cdb = (struct ARCMSR_CDB *)&srb->arcmsr_cdb;
 
 	bus_dmamap_sync(acb->srb_dmat, acb->srb_dmamap, (srb->srb_flags & SRB_FLAG_WRITE) ? BUS_DMASYNC_POSTWRITE:BUS_DMASYNC_POSTREAD);
 	atomic_add_int(&acb->srboutstandingcount, 1);
-	srb->srb_state=ARCMSR_SRB_START;
+	srb->srb_state = ARCMSR_SRB_START;
 
 	switch (acb->adapter_type) {
 	case ACB_ADAPTER_TYPE_A: {
 			if(arcmsr_cdb->Flags & ARCMSR_CDB_FLAG_SGL_BSIZE) {
-				CHIP_REG_WRITE32(HBA_MessageUnit, 0, inbound_queueport, cdb_shifted_phyaddr|ARCMSR_SRBPOST_FLAG_SGL_BSIZE);
+				CHIP_REG_WRITE32(HBA_MessageUnit, 0, inbound_queueport, cdb_phyaddr_low|ARCMSR_SRBPOST_FLAG_SGL_BSIZE);
 			} else {
-				CHIP_REG_WRITE32(HBA_MessageUnit, 0, inbound_queueport, cdb_shifted_phyaddr);
+				CHIP_REG_WRITE32(HBA_MessageUnit, 0, inbound_queueport, cdb_phyaddr_low);
 			}
 		}
 		break;
 	case ACB_ADAPTER_TYPE_B: {
-			struct HBB_MessageUnit *phbbmu=(struct HBB_MessageUnit *)acb->pmu;
+			struct HBB_MessageUnit *phbbmu = (struct HBB_MessageUnit *)acb->pmu;
 			int ending_index, index;
 
-			index=phbbmu->postq_index;
-			ending_index=((index+1)%ARCMSR_MAX_HBB_POSTQUEUE);
-			phbbmu->post_qbuffer[ending_index]=0;
+			index = phbbmu->postq_index;
+			ending_index = ((index+1) % ARCMSR_MAX_HBB_POSTQUEUE);
+			phbbmu->post_qbuffer[ending_index] = 0;
 			if(arcmsr_cdb->Flags & ARCMSR_CDB_FLAG_SGL_BSIZE) {
-				phbbmu->post_qbuffer[index]= cdb_shifted_phyaddr|ARCMSR_SRBPOST_FLAG_SGL_BSIZE;
+				phbbmu->post_qbuffer[index] = cdb_phyaddr_low | ARCMSR_SRBPOST_FLAG_SGL_BSIZE;
 			} else {
-				phbbmu->post_qbuffer[index]= cdb_shifted_phyaddr;
+				phbbmu->post_qbuffer[index] = cdb_phyaddr_low;
 			}
 			index++;
 			index %= ARCMSR_MAX_HBB_POSTQUEUE;     /*if last index number set it to 0 */
-			phbbmu->postq_index=index;
+			phbbmu->postq_index = index;
 			CHIP_REG_WRITE32(HBB_DOORBELL, 0, drv2iop_doorbell, ARCMSR_DRV2IOP_CDB_POSTED);
 		}
 		break;
-    case ACB_ADAPTER_TYPE_C:
-        {
+    case ACB_ADAPTER_TYPE_C: {
             u_int32_t ccb_post_stamp, arc_cdb_size, cdb_phyaddr_hi32;
 
-            arc_cdb_size=(srb->arc_cdb_size>0x300)?0x300:srb->arc_cdb_size;
-            ccb_post_stamp=(cdb_shifted_phyaddr | ((arc_cdb_size-1) >> 6) | 1);
+            arc_cdb_size = (srb->arc_cdb_size > 0x300) ? 0x300 : srb->arc_cdb_size;
+            ccb_post_stamp = (cdb_phyaddr_low | ((arc_cdb_size-1) >> 6) | 1);
 			cdb_phyaddr_hi32 = acb->srb_phyaddr.B.phyadd_high;
             if(cdb_phyaddr_hi32)
             {
@@ -972,33 +1046,67 @@ static void arcmsr_post_srb(struct AdapterControlBlock *acb, struct CommandContr
             }
         }
         break;
+	case ACB_ADAPTER_TYPE_D: {
+			struct HBD_MessageUnit0 *phbdmu = (struct HBD_MessageUnit0 *)acb->pmu;
+			u_int16_t index_stripped;
+			u_int16_t postq_index;
+			struct InBound_SRB *pinbound_srb;
+
+			ARCMSR_LOCK_ACQUIRE(&acb->postDone_lock);
+			postq_index = phbdmu->postq_index;
+			pinbound_srb = (struct InBound_SRB *)&phbdmu->post_qbuffer[postq_index & 0xFF];
+			pinbound_srb->addressHigh = srb->cdb_phyaddr_high;
+			pinbound_srb->addressLow = srb->cdb_phyaddr_low;
+			pinbound_srb->length = srb->arc_cdb_size >> 2;
+			arcmsr_cdb->Context = srb->cdb_phyaddr_low;
+			if (postq_index & 0x4000) {
+				index_stripped = postq_index & 0xFF;
+				index_stripped += 1;
+				index_stripped %= ARCMSR_MAX_HBD_POSTQUEUE;
+				phbdmu->postq_index = index_stripped ? (index_stripped | 0x4000) : index_stripped;
+			} else {
+				index_stripped = postq_index;
+				index_stripped += 1;
+				index_stripped %= ARCMSR_MAX_HBD_POSTQUEUE;
+				phbdmu->postq_index = index_stripped ? index_stripped : (index_stripped | 0x4000);
+			}
+			CHIP_REG_WRITE32(HBD_MessageUnit, 0, inboundlist_write_pointer, postq_index);
+			ARCMSR_LOCK_RELEASE(&acb->postDone_lock);
+		}
+		break;
 	}
 }
 /*
 ************************************************************************
 ************************************************************************
 */
-static struct QBUFFER * arcmsr_get_iop_rqbuffer( struct AdapterControlBlock *acb)
+static struct QBUFFER *arcmsr_get_iop_rqbuffer( struct AdapterControlBlock *acb)
 {
 	struct QBUFFER *qbuffer=NULL;
 
 	switch (acb->adapter_type) {
 	case ACB_ADAPTER_TYPE_A: {
-			struct HBA_MessageUnit *phbamu=(struct HBA_MessageUnit *)acb->pmu;
+			struct HBA_MessageUnit *phbamu = (struct HBA_MessageUnit *)acb->pmu;
 
-			qbuffer=(struct QBUFFER *)&phbamu->message_rbuffer;
+			qbuffer = (struct QBUFFER *)&phbamu->message_rbuffer;
 		}
 		break;
 	case ACB_ADAPTER_TYPE_B: {
-			struct HBB_MessageUnit *phbbmu=(struct HBB_MessageUnit *)acb->pmu;
+			struct HBB_MessageUnit *phbbmu = (struct HBB_MessageUnit *)acb->pmu;
 
-			qbuffer=(struct QBUFFER *)&phbbmu->hbb_rwbuffer->message_rbuffer;
+			qbuffer = (struct QBUFFER *)&phbbmu->hbb_rwbuffer->message_rbuffer;
 		}
 		break;
 	case ACB_ADAPTER_TYPE_C: {
-			struct HBC_MessageUnit *phbcmu=(struct HBC_MessageUnit *)acb->pmu;
+			struct HBC_MessageUnit *phbcmu = (struct HBC_MessageUnit *)acb->pmu;
 
-			qbuffer=(struct QBUFFER *)&phbcmu->message_rbuffer;
+			qbuffer = (struct QBUFFER *)&phbcmu->message_rbuffer;
+		}
+		break;
+	case ACB_ADAPTER_TYPE_D: {
+			struct HBD_MessageUnit0 *phbdmu = (struct HBD_MessageUnit0 *)acb->pmu;
+	
+			qbuffer = (struct QBUFFER *)&phbdmu->phbdmu->message_rbuffer;
 		}
 		break;
 	}
@@ -1008,27 +1116,33 @@ static struct QBUFFER * arcmsr_get_iop_rqbuffer( struct AdapterControlBlock *acb
 ************************************************************************
 ************************************************************************
 */
-static struct QBUFFER * arcmsr_get_iop_wqbuffer( struct AdapterControlBlock *acb)
+static struct QBUFFER *arcmsr_get_iop_wqbuffer( struct AdapterControlBlock *acb)
 {
-	struct QBUFFER *qbuffer=NULL;
+	struct QBUFFER *qbuffer = NULL;
 
 	switch (acb->adapter_type) {
 	case ACB_ADAPTER_TYPE_A: {
-			struct HBA_MessageUnit *phbamu=(struct HBA_MessageUnit *)acb->pmu;
+			struct HBA_MessageUnit *phbamu = (struct HBA_MessageUnit *)acb->pmu;
 
-			qbuffer=(struct QBUFFER *)&phbamu->message_wbuffer;
+			qbuffer = (struct QBUFFER *)&phbamu->message_wbuffer;
 		}
 		break;
 	case ACB_ADAPTER_TYPE_B: {
-			struct HBB_MessageUnit *phbbmu=(struct HBB_MessageUnit *)acb->pmu;
+			struct HBB_MessageUnit *phbbmu = (struct HBB_MessageUnit *)acb->pmu;
 
-			qbuffer=(struct QBUFFER *)&phbbmu->hbb_rwbuffer->message_wbuffer;
+			qbuffer = (struct QBUFFER *)&phbbmu->hbb_rwbuffer->message_wbuffer;
 		}
 		break;
 	case ACB_ADAPTER_TYPE_C: {
-			struct HBC_MessageUnit *phbcmu=(struct HBC_MessageUnit *)acb->pmu;
+			struct HBC_MessageUnit *phbcmu = (struct HBC_MessageUnit *)acb->pmu;
 
-			qbuffer=(struct QBUFFER *)&phbcmu->message_wbuffer;
+			qbuffer = (struct QBUFFER *)&phbcmu->message_wbuffer;
+		}
+		break;
+	case ACB_ADAPTER_TYPE_D: {
+			struct HBD_MessageUnit0 *phbdmu = (struct HBD_MessageUnit0 *)acb->pmu;
+	
+			qbuffer = (struct QBUFFER *)&phbdmu->phbdmu->message_wbuffer;
 		}
 		break;
 	}
@@ -1055,6 +1169,12 @@ static void arcmsr_iop_message_read(struct AdapterControlBlock *acb)
 			/* let IOP know data has been read */
 			CHIP_REG_WRITE32(HBC_MessageUnit, 0, inbound_doorbell, ARCMSR_HBCMU_DRV2IOP_DATA_READ_OK);
 		}
+		break;
+	case ACB_ADAPTER_TYPE_D: {
+			/* let IOP know data has been read */
+			CHIP_REG_WRITE32(HBD_MessageUnit, 0, inbound_doorbell, ARCMSR_HBDMU_DRV2IOP_DATA_OUT_READ);
+		}
+		break;
 	}
 }
 /*
@@ -1088,37 +1208,14 @@ static void arcmsr_iop_message_wrote(struct AdapterControlBlock *acb)
 			CHIP_REG_WRITE32(HBC_MessageUnit, 0, inbound_doorbell, ARCMSR_HBCMU_DRV2IOP_DATA_WRITE_OK);
 		}
 		break;
-	}
-}
-/*
-**********************************************************************
-**********************************************************************
-*/
-static void arcmsr_post_ioctldata2iop(struct AdapterControlBlock *acb)
-{
-	u_int8_t *pQbuffer;
-	struct QBUFFER *pwbuffer;
-	u_int8_t * iop_data;
-	int32_t allxfer_len=0;
-
-	pwbuffer=arcmsr_get_iop_wqbuffer(acb);
-	iop_data=(u_int8_t *)pwbuffer->data;
-	if(acb->acb_flags & ACB_F_MESSAGE_WQBUFFER_READ) {
-		acb->acb_flags &= (~ACB_F_MESSAGE_WQBUFFER_READ);
-		while((acb->wqbuf_firstindex!=acb->wqbuf_lastindex)
-			&& (allxfer_len<124)) {
-			pQbuffer=&acb->wqbuffer[acb->wqbuf_firstindex];
-			memcpy(iop_data, pQbuffer, 1);
-			acb->wqbuf_firstindex++;
-			acb->wqbuf_firstindex %=ARCMSR_MAX_QBUFFER; /*if last index number set it to 0 */
-			iop_data++;
-			allxfer_len++;
+	case ACB_ADAPTER_TYPE_D: {
+			/*
+			** push inbound doorbell tell iop, driver data write ok 
+			** and wait reply on next hwinterrupt for next Qbuffer post
+			*/
+			CHIP_REG_WRITE32(HBD_MessageUnit, 0, inbound_doorbell, ARCMSR_HBDMU_DRV2IOP_DATA_IN_READY);
 		}
-		pwbuffer->data_len=allxfer_len;
-		/*
-		** push inbound doorbell and wait reply at hwinterrupt routine for next Qbuffer post
-		*/
-		arcmsr_iop_message_wrote(acb);
+		break;
 	}
 }
 /*
@@ -1127,14 +1224,13 @@ static void arcmsr_post_ioctldata2iop(struct AdapterControlBlock *acb)
 */
 static void arcmsr_stop_hba_bgrb(struct AdapterControlBlock *acb)
 {
-	acb->acb_flags &=~ACB_F_MSG_START_BGRB;
+	acb->acb_flags &= ~ACB_F_MSG_START_BGRB;
 	CHIP_REG_WRITE32(HBA_MessageUnit,
 	0, inbound_msgaddr0, ARCMSR_INBOUND_MESG0_STOP_BGRB);
 	if(!arcmsr_hba_wait_msgint_ready(acb)) {
 		kprintf("arcmsr%d: wait 'stop adapter background rebuild' timeout \n"
 			, acb->pci_unit);
 	}
-	return;
 }
 /*
 ************************************************************************
@@ -1156,7 +1252,7 @@ static void arcmsr_stop_hbb_bgrb(struct AdapterControlBlock *acb)
 */
 static void arcmsr_stop_hbc_bgrb(struct AdapterControlBlock *acb)
 {
-	acb->acb_flags &=~ACB_F_MSG_START_BGRB;
+	acb->acb_flags &= ~ACB_F_MSG_START_BGRB;
 	CHIP_REG_WRITE32(HBC_MessageUnit, 0, inbound_msgaddr0, ARCMSR_INBOUND_MESG0_STOP_BGRB);
 	CHIP_REG_WRITE32(HBC_MessageUnit, 0, inbound_doorbell,ARCMSR_HBCMU_DRV2IOP_MESSAGE_CMD_DONE);
 	if(!arcmsr_hbc_wait_msgint_ready(acb)) {
@@ -1167,6 +1263,18 @@ static void arcmsr_stop_hbc_bgrb(struct AdapterControlBlock *acb)
 ************************************************************************
 ************************************************************************
 */
+static void arcmsr_stop_hbd_bgrb(struct AdapterControlBlock *acb)
+{
+	acb->acb_flags &= ~ACB_F_MSG_START_BGRB;
+	CHIP_REG_WRITE32(HBD_MessageUnit, 0, inbound_msgaddr0, ARCMSR_INBOUND_MESG0_STOP_BGRB);
+	if(!arcmsr_hbd_wait_msgint_ready(acb)) {
+		kprintf("arcmsr%d: wait 'stop adapter background rebulid' timeout \n", acb->pci_unit);
+	}
+}
+/*
+************************************************************************
+************************************************************************
+*/
 static void arcmsr_stop_adapter_bgrb(struct AdapterControlBlock *acb)
 {
 	switch (acb->adapter_type) {
@@ -1182,24 +1290,102 @@ static void arcmsr_stop_adapter_bgrb(struct AdapterControlBlock *acb)
 			arcmsr_stop_hbc_bgrb(acb);
 		}
 		break;
+	case ACB_ADAPTER_TYPE_D: {
+			arcmsr_stop_hbd_bgrb(acb);
+		}
+		break;
 	}
 }
 /*
 ************************************************************************
 ************************************************************************
 */
-static void arcmsr_poll(struct cam_sim * psim)
+static void arcmsr_poll(struct cam_sim *psim)
 {
 	struct AdapterControlBlock *acb;
 	int	mutex;
 
 	acb = (struct AdapterControlBlock *)cam_sim_softc(psim);
-	mutex = lockstatus(&acb->qbuffer_lock, curthread);
+	mutex = lockstatus(&acb->isr_lock, curthread);
 	if( mutex == 0 )
-		ARCMSR_LOCK_ACQUIRE(&acb->qbuffer_lock);
+		ARCMSR_LOCK_ACQUIRE(&acb->isr_lock);
 	arcmsr_interrupt(acb);
 	if( mutex == 0 )
-		ARCMSR_LOCK_RELEASE(&acb->qbuffer_lock);
+		ARCMSR_LOCK_RELEASE(&acb->isr_lock);
+}
+/*
+**************************************************************************
+**************************************************************************
+*/
+static u_int32_t arcmsr_Read_iop_rqbuffer_data_D(struct AdapterControlBlock *acb,
+    struct QBUFFER *prbuffer) {
+
+	u_int8_t *pQbuffer;
+	u_int8_t *buf1 = 0;
+	u_int32_t *iop_data, *buf2 = 0;
+	u_int32_t iop_len, data_len;
+
+	iop_data = (u_int32_t *)prbuffer->data;
+	iop_len = (u_int32_t)prbuffer->data_len;
+	if ( iop_len > 0 )
+	{
+		buf1 = kmalloc(128, M_DEVBUF, M_NOWAIT | M_ZERO);
+		buf2 = (u_int32_t *)buf1;
+		if( buf1 == NULL)
+			return (0);
+		data_len = iop_len;
+		while(data_len >= 4)
+		{
+			*buf2++ = *iop_data++;
+			data_len -= 4;
+		}
+		if(data_len)
+			*buf2 = *iop_data;
+		buf2 = (u_int32_t *)buf1;
+	}
+	while (iop_len > 0) {
+		pQbuffer = &acb->rqbuffer[acb->rqbuf_lastindex];
+		*pQbuffer = *buf1;
+		acb->rqbuf_lastindex++;
+		/* if last, index number set it to 0 */
+		acb->rqbuf_lastindex %= ARCMSR_MAX_QBUFFER;
+		buf1++;
+		iop_len--;
+	}
+	if(buf2)
+		kfree( (u_int8_t *)buf2, M_DEVBUF);
+	/* let IOP know data has been read */
+	arcmsr_iop_message_read(acb);
+	return (1);
+}
+/*
+**************************************************************************
+**************************************************************************
+*/
+static u_int32_t arcmsr_Read_iop_rqbuffer_data(struct AdapterControlBlock *acb,
+    struct QBUFFER *prbuffer) {
+
+	u_int8_t *pQbuffer;
+	u_int8_t *iop_data;
+	u_int32_t iop_len;
+
+	if(acb->adapter_type & (ACB_ADAPTER_TYPE_C | ACB_ADAPTER_TYPE_D)) {
+		return(arcmsr_Read_iop_rqbuffer_data_D(acb, prbuffer));
+	}
+	iop_data = (u_int8_t *)prbuffer->data;
+	iop_len = (u_int32_t)prbuffer->data_len;
+	while (iop_len > 0) {
+		pQbuffer = &acb->rqbuffer[acb->rqbuf_lastindex];
+		*pQbuffer = *iop_data;
+		acb->rqbuf_lastindex++;
+		/* if last, index number set it to 0 */
+		acb->rqbuf_lastindex %= ARCMSR_MAX_QBUFFER;
+		iop_data++;
+		iop_len--;
+	}
+	/* let IOP know data has been read */
+	arcmsr_iop_message_read(acb);
+	return (1);
 }
 /*
 **************************************************************************
@@ -1208,31 +1394,95 @@ static void arcmsr_poll(struct cam_sim * psim)
 static void arcmsr_iop2drv_data_wrote_handle(struct AdapterControlBlock *acb)
 {
 	struct QBUFFER *prbuffer;
+	int my_empty_len;
+	
+	/*check this iop data if overflow my rqbuffer*/
+	ARCMSR_LOCK_ACQUIRE(&acb->qbuffer_lock);
+	prbuffer = arcmsr_get_iop_rqbuffer(acb);
+	my_empty_len = (acb->rqbuf_lastindex - acb->rqbuf_firstindex - 1) &
+	    (ARCMSR_MAX_QBUFFER-1);
+	if(my_empty_len >= prbuffer->data_len) {
+		if(arcmsr_Read_iop_rqbuffer_data(acb, prbuffer) == 0)
+			acb->acb_flags |= ACB_F_IOPDATA_OVERFLOW;
+	} else {
+		acb->acb_flags |= ACB_F_IOPDATA_OVERFLOW;
+	}
+	ARCMSR_LOCK_RELEASE(&acb->qbuffer_lock);
+}
+/*
+**********************************************************************
+**********************************************************************
+*/
+static void arcmsr_Write_data_2iop_wqbuffer_D(struct AdapterControlBlock *acb)
+{
 	u_int8_t *pQbuffer;
+	struct QBUFFER *pwbuffer;
+	u_int8_t *buf1 = 0;
+	u_int32_t *iop_data, *buf2 = 0;
+	u_int32_t allxfer_len = 0, data_len;
+	
+	if(acb->acb_flags & ACB_F_MESSAGE_WQBUFFER_READ) {
+		buf1 = kmalloc(128, M_DEVBUF, M_NOWAIT | M_ZERO);
+		buf2 = (u_int32_t *)buf1;
+		if( buf1 == NULL)
+			return;
+
+		acb->acb_flags &= (~ACB_F_MESSAGE_WQBUFFER_READ);
+		pwbuffer = arcmsr_get_iop_wqbuffer(acb);
+		iop_data = (u_int32_t *)pwbuffer->data;
+		while((acb->wqbuf_firstindex != acb->wqbuf_lastindex) 
+			&& (allxfer_len < 124)) {
+			pQbuffer = &acb->wqbuffer[acb->wqbuf_firstindex];
+			*buf1 = *pQbuffer;
+			acb->wqbuf_firstindex++;
+			acb->wqbuf_firstindex %= ARCMSR_MAX_QBUFFER;
+			buf1++;
+			allxfer_len++;
+		}
+		pwbuffer->data_len = allxfer_len;
+		data_len = allxfer_len;
+		buf1 = (u_int8_t *)buf2;
+		while(data_len >= 4)
+		{
+			*iop_data++ = *buf2++;
+			data_len -= 4;
+		}
+		if(data_len)
+			*iop_data = *buf2;
+		kfree( buf1, M_DEVBUF);
+		arcmsr_iop_message_wrote(acb);
+	}
+}
+/*
+**********************************************************************
+**********************************************************************
+*/
+static void arcmsr_Write_data_2iop_wqbuffer(struct AdapterControlBlock *acb)
+{
+	u_int8_t *pQbuffer;
+	struct QBUFFER *pwbuffer;
 	u_int8_t *iop_data;
-	int my_empty_len, iop_len, rqbuf_firstindex, rqbuf_lastindex;
+	int32_t allxfer_len=0;
 
-	/*check this iop data if overflow my rqbuffer*/
-	rqbuf_lastindex=acb->rqbuf_lastindex;
-	rqbuf_firstindex=acb->rqbuf_firstindex;
-	prbuffer=arcmsr_get_iop_rqbuffer(acb);
-	iop_data=(u_int8_t *)prbuffer->data;
-	iop_len=prbuffer->data_len;
-	my_empty_len=(rqbuf_firstindex-rqbuf_lastindex-1)&(ARCMSR_MAX_QBUFFER-1);
-	if(my_empty_len>=iop_len) {
-		while(iop_len > 0) {
-			pQbuffer=&acb->rqbuffer[rqbuf_lastindex];
-			memcpy(pQbuffer, iop_data, 1);
-			rqbuf_lastindex++;
-			rqbuf_lastindex %= ARCMSR_MAX_QBUFFER;/*if last index number set it to 0 */
+	if(acb->adapter_type & (ACB_ADAPTER_TYPE_C | ACB_ADAPTER_TYPE_D)) {
+		arcmsr_Write_data_2iop_wqbuffer_D(acb);
+		return;
+	}
+	if(acb->acb_flags & ACB_F_MESSAGE_WQBUFFER_READ) {
+		acb->acb_flags &= (~ACB_F_MESSAGE_WQBUFFER_READ);
+		pwbuffer = arcmsr_get_iop_wqbuffer(acb);
+		iop_data = (u_int8_t *)pwbuffer->data;
+		while((acb->wqbuf_firstindex != acb->wqbuf_lastindex) 
+			&& (allxfer_len < 124)) {
+			pQbuffer = &acb->wqbuffer[acb->wqbuf_firstindex];
+			*iop_data = *pQbuffer;
+			acb->wqbuf_firstindex++;
+			acb->wqbuf_firstindex %= ARCMSR_MAX_QBUFFER;
 			iop_data++;
-			iop_len--;
+			allxfer_len++;
 		}
-		acb->rqbuf_lastindex=rqbuf_lastindex;
-		arcmsr_iop_message_read(acb);
-		/*signature, let IOP know data has been read */
-	} else {
-		acb->acb_flags|=ACB_F_IOPDATA_OVERFLOW;
+		pwbuffer->data_len = allxfer_len;
+		arcmsr_iop_message_wrote(acb);
 	}
 }
 /*
@@ -1241,6 +1491,7 @@ static void arcmsr_iop2drv_data_wrote_handle(struct AdapterControlBlock *acb)
 */
 static void arcmsr_iop2drv_data_read_handle(struct AdapterControlBlock *acb)
 {
+	ARCMSR_LOCK_ACQUIRE(&acb->qbuffer_lock);
 	acb->acb_flags |= ACB_F_MESSAGE_WQBUFFER_READ;
 	/*
 	*****************************************************************
@@ -1248,61 +1499,51 @@ static void arcmsr_iop2drv_data_read_handle(struct AdapterControlBlock *acb)
 	**   in my post bag, now is the time to send them into Areca's firmware
 	*****************************************************************
 	*/
-	if(acb->wqbuf_firstindex!=acb->wqbuf_lastindex) {
-		u_int8_t *pQbuffer;
-		struct QBUFFER *pwbuffer;
-		u_int8_t *iop_data;
-		int allxfer_len=0;
-
-		acb->acb_flags &= (~ACB_F_MESSAGE_WQBUFFER_READ);
-		pwbuffer=arcmsr_get_iop_wqbuffer(acb);
-		iop_data=(u_int8_t *)pwbuffer->data;
-		while((acb->wqbuf_firstindex!=acb->wqbuf_lastindex)
-			&& (allxfer_len<124)) {
-			pQbuffer=&acb->wqbuffer[acb->wqbuf_firstindex];
-			memcpy(iop_data, pQbuffer, 1);
-			acb->wqbuf_firstindex++;
-			acb->wqbuf_firstindex %=ARCMSR_MAX_QBUFFER; /*if last index number set it to 0 */
-			iop_data++;
-			allxfer_len++;
-		}
-		pwbuffer->data_len=allxfer_len;
-		/*
-		** push inbound doorbell tell iop driver data write ok
-		** and wait reply on next hwinterrupt for next Qbuffer post
-		*/
-		arcmsr_iop_message_wrote(acb);
+	if(acb->wqbuf_firstindex != acb->wqbuf_lastindex) {
+		arcmsr_Write_data_2iop_wqbuffer(acb);
 	}
-	if(acb->wqbuf_firstindex==acb->wqbuf_lastindex) {
+	if(acb->wqbuf_firstindex == acb->wqbuf_lastindex) {
 		acb->acb_flags |= ACB_F_MESSAGE_WQBUFFER_CLEARED;
 	}
+	ARCMSR_LOCK_RELEASE(&acb->qbuffer_lock);
 }
-
+/*
+**************************************************************************
+**************************************************************************
+*/
 static void arcmsr_rescanLun_cb(struct cam_periph *periph, union ccb *ccb)
 {
 /*
 	if (ccb->ccb_h.status != CAM_REQ_CMP)
-		kprintf("arcmsr_rescanLun_cb: Rescan Target=%x, lun=%x, failure status=%x\n",ccb->ccb_h.target_id,ccb->ccb_h.target_lun,ccb->ccb_h.status);
+		kprintf("arcmsr_rescanLun_cb: Rescan Target=%x, lun=%x,"
+		    "failure status=%x\n", ccb->ccb_h.target_id,
+		    ccb->ccb_h.target_lun, ccb->ccb_h.status);
 	else
 		kprintf("arcmsr_rescanLun_cb: Rescan lun successfully!\n");
 */
 	xpt_free_path(ccb->ccb_h.path);
+	xpt_free_ccb(ccb);
 }
 
 static void	arcmsr_rescan_lun(struct AdapterControlBlock *acb, int target, int lun)
 {
 	struct cam_path     *path;
-	union ccb            ccb;
+	union ccb           *ccb;
 
-	if (xpt_create_path(&path, xpt_periph, cam_sim_path(acb->psim), target, lun) != CAM_REQ_CMP)
+	if ((ccb = (union ccb *)xpt_alloc_ccb()) == NULL)
+ 		return;
+	if (xpt_create_path(&path, NULL, cam_sim_path(acb->psim), target, lun) != CAM_REQ_CMP)
+	{
+		xpt_free_ccb(ccb);
 		return;
+	}
 /*	kprintf("arcmsr_rescan_lun: Rescan Target=%x, Lun=%x\n", target, lun); */
-	bzero(&ccb, sizeof(union ccb));
-	xpt_setup_ccb(&ccb.ccb_h, path, 5);
-	ccb.ccb_h.func_code = XPT_SCAN_LUN;
-	ccb.ccb_h.cbfcnp = arcmsr_rescanLun_cb;
-	ccb.crcn.flags = CAM_FLAG_NONE;
-	xpt_action(&ccb);
+	bzero(ccb, sizeof(union ccb));
+	xpt_setup_ccb(&ccb->ccb_h, path, 5);
+	ccb->ccb_h.func_code = XPT_SCAN_LUN;
+	ccb->ccb_h.cbfcnp = arcmsr_rescanLun_cb;
+	ccb->crcn.flags = CAM_FLAG_NONE;
+	xpt_action(ccb);
 }
 
 
@@ -1312,7 +1553,6 @@ static void arcmsr_abort_dr_ccbs(struct AdapterControlBlock *acb, int target, in
 	u_int32_t intmask_org;
 	int i;
 
-	ARCMSR_LOCK_ACQUIRE(&acb->qbuffer_lock);
 	/* disable all outbound interrupts */
 	intmask_org = arcmsr_disable_allintr(acb);
 	for (i = 0; i < ARCMSR_MAX_FREESRB_NUM; i++)
@@ -1331,10 +1571,7 @@ static void arcmsr_abort_dr_ccbs(struct AdapterControlBlock *acb, int target, in
 	}
 	/* enable outbound Post Queue, outbound doorbell Interrupt */
 	arcmsr_enable_allintr(acb, intmask_org);
-	ARCMSR_LOCK_RELEASE(&acb->qbuffer_lock);
 }
-
-
 /*
 **************************************************************************
 **************************************************************************
@@ -1348,7 +1585,7 @@ static void arcmsr_dr_handle(struct AdapterControlBlock *acb) {
 	switch (acb->adapter_type) {
 	case ACB_ADAPTER_TYPE_A:
 			devicemap = offsetof(struct HBA_MessageUnit, msgcode_rwbuffer[ARCMSR_FW_DEVMAP_OFFSET]);
-			for (target= 0; target < 4; target++)
+			for (target = 0; target < 4; target++) 
 			{
 		deviceMapCurrent[target]=bus_space_read_4(acb->btag[0], acb->bhandle[0],  devicemap);
 		devicemap += 4;
@@ -1357,7 +1594,7 @@ static void arcmsr_dr_handle(struct AdapterControlBlock *acb) {
 
 	case ACB_ADAPTER_TYPE_B:
 			devicemap = offsetof(struct HBB_RWBUFFER, msgcode_rwbuffer[ARCMSR_FW_DEVMAP_OFFSET]);
-			for (target= 0; target < 4; target++)
+			for (target = 0; target < 4; target++) 
 			{
 		deviceMapCurrent[target]=bus_space_read_4(acb->btag[1], acb->bhandle[1],  devicemap);
 		devicemap += 4;
